﻿
var iconDrag = "<span class='webix_icon fa-bars'></span>";
var iconEditplicy = "<span class='webix_icon fa-pencil ruleedit1'></span>";
var iconDelete = "<span class='webix_icon fa-trash'></span>";
var iconCopy = "<span class='webix_icon fa-copy'></span>";
var iconInfo = "<span class='webix_icon fa-info-circle'></span>";

var rulecopy = [];

var rule_options = [{ id: 0, value: "Select condition" },
{ id: 1, value: "The sender is..." },
{ id: 2, value: "The sender address contains..." },
{ id: 3, value: "The recipient is..." },
{ id: 4, value: "The recipient address contains..." },
{ id: 5, value: "GSG only - The email header contains..." },
{ id: 6, value: "The subject contains..." },
{ id: 7, value: "The body contains..." },
{ id: 8, value: "The body contains any credit card number" },
{ id: 9, value: "The email contains one or more attachments" },
{ id: 10, value: "Office attachments' classification contains..." },
{ id: 11, value: "Any email attachment filename contains..." },
{ id: 12, value: "Triggered by classification software" }];

//2021-07-19 KMB 3526, classification option array
var classification_options = [];
//2021-07-19 KMB 3526, classification option array

//2021-10-05 KMB #3704 error message if rule name is present
var g_str_message = "";
//2021-10-05 KMB #3704   error message if rule name is present
//2021-08-06 KMB default classification value
var g_default_classification_value = 0;
//2021-08-06 KMB default classification value
var Base64 = { _keyStr: "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=", encode: function (n) { var f = "", e, t, i, s, h, o, r, u = 0; for (n = Base64._utf8_encode(n); u < n.length;) e = n.charCodeAt(u++), t = n.charCodeAt(u++), i = n.charCodeAt(u++), s = e >> 2, h = (e & 3) << 4 | t >> 4, o = (t & 15) << 2 | i >> 6, r = i & 63, isNaN(t) ? o = r = 64 : isNaN(i) && (r = 64), f = f + this._keyStr.charAt(s) + this._keyStr.charAt(h) + this._keyStr.charAt(o) + this._keyStr.charAt(r); return f }, decode: function (n) { var t = "", e, o, s, h, u, r, f, i = 0; for (n = n.replace(/[^A-Za-z0-9\+\/\=]/g, ""); i < n.length;) h = this._keyStr.indexOf(n.charAt(i++)), u = this._keyStr.indexOf(n.charAt(i++)), r = this._keyStr.indexOf(n.charAt(i++)), f = this._keyStr.indexOf(n.charAt(i++)), e = h << 2 | u >> 4, o = (u & 15) << 4 | r >> 2, s = (r & 3) << 6 | f, t = t + String.fromCharCode(e), r != 64 && (t = t + String.fromCharCode(o)), f != 64 && (t = t + String.fromCharCode(s)); return Base64._utf8_decode(t) }, _utf8_encode: function (n) { var i, r, t; for (n = n.replace(/\r\n/g, "\n"), i = "", r = 0; r < n.length; r++) t = n.charCodeAt(r), t < 128 ? i += String.fromCharCode(t) : t > 127 && t < 2048 ? (i += String.fromCharCode(t >> 6 | 192), i += String.fromCharCode(t & 63 | 128)) : (i += String.fromCharCode(t >> 12 | 224), i += String.fromCharCode(t >> 6 & 63 | 128), i += String.fromCharCode(t & 63 | 128)); return i }, _utf8_decode: function (n) { for (var r = "", t = 0, i = c1 = c2 = 0; t < n.length;) i = n.charCodeAt(t), i < 128 ? (r += String.fromCharCode(i), t++) : i > 191 && i < 224 ? (c2 = n.charCodeAt(t + 1), r += String.fromCharCode((i & 31) << 6 | c2 & 63), t += 2) : (c2 = n.charCodeAt(t + 1), c3 = n.charCodeAt(t + 2), r += String.fromCharCode((i & 15) << 12 | (c2 & 63) << 6 | c3 & 63), t += 3); return r } };
function showFormRule(n, t, i) {
    $$(n).getBody().focus();
    $$(n).show();

    if (i != -1) {
        var r = t[i];
        var ruledataDecoded = "";
        if (r.ruledata != "") {
            ruledataDecoded = Base64.decode(r.ruledata);
        }
        r.description = r.description.replace("&amp;", "&");
        r.description = r.description.replace("&lt;", "<");
        r.description = r.description.replace("&gt;", ">");

        //2021-08-04 KMB policy description
        var ui_descriptionDecoded = "";
        if (r.ui_description && r.ui_description != "") {
            ui_descriptionDecoded = Base64.decode(r.ui_description);
        }
        //2021-08-04 KMB policy description
        //2021-07-19KMB 3526 check if secure_type present, if not present, new values should be set to default values
        if (r.secure_type === undefined || r.secure_type === "") {

            $$("ruleForm").setValues({
                "description": r.description,
                "rule": r.rule,
                "ruledata": ruledataDecoded,
                "outlook": r.outlook,
                "gsg": r.gsg,
                "audit": r.audit,
                "enabled": r.enabled,
                "index": r.index,
                //2021-07-19 KMB 3526
                "secure_type": "encrypt",
                "ui_authorisationrequired": 0,
                "ui_classification": g_default_classification_value,
                "ui_digitalsign": 0,
                "ui_forwardblock": 0,
                "ui_geofence": 0,
                "ui_notification": 0,
                "ui_replyblock": 0,
                "ui_validityperiod": "",
                "ui_yotiverification": 0,
                "validitytxt": "",
                //2021-07-19 KMB 3526
                //2021-08-04 KMB policy description
                "ui_description":""
                //2021-08-04 KMB policy description
            });

        }
        else {
            $$("ruleForm").setValues({
                "description": r.description,
                "rule": r.rule,
                "ruledata": ruledataDecoded,
                "outlook": r.outlook,
                "gsg": r.gsg,
                "audit": r.audit,
                "enabled": r.enabled,
                "index": r.index,
                //2021-07-19 KMB 3526
                "secure_type": r.secure_type,
                "ui_authorisationrequired": r.ui_authorisationrequired,
                "ui_classification": r.ui_classification,
                "ui_digitalsign": r.ui_digitalsign,
                "ui_forwardblock": r.ui_forwardblock,
                "ui_geofence": r.ui_geofence,
                "ui_notification": r.ui_notification,
                "ui_replyblock": r.ui_replyblock,
                "ui_validityperiod": r.ui_validityperiod,
                "ui_yotiverification": r.ui_yotiverification,
                //2021-07-19 KMB 3526
                //2021-08-04 KMB  read policy description
                "ui_description": ui_descriptionDecoded
                //2021-08-04 KMB  read policy description
            });
            //2021-07-19 KMB 3526  update validity period in years months and days as a text
            updateValidityPeriod(r.ui_validityperiod);
            //2021-07-19 KMB 3526  update validity period in years months and days as a text
        }

        nCurrentIndex = i
    }
    else {
        $$("ruleForm").setValues({
            "description": "New Rule",
            "rule": 0,
            "ruledata": "",
            "outlook": 1,
            "gsg": 1,
            "audit": 1,
            "enabled": 1,
            "index": -1,
            //2021-07-19 KMB 3526
            "secure_type": "encrypt",
            "ui_authorisationrequired": 0,
            "ui_classification": g_default_classification_value,
            "ui_digitalsign": 0,
            "ui_forwardblock": 0,
            "ui_geofence": 0,
            "ui_notification": 0,
            "ui_replyblock": 0,
            "ui_validityperiod": "",
            "ui_yotiverification": 0,
            "validitytxt": "",
            //2021-07-19 KMB 3526
            //2021-08-04 KMB policy description
            "ui_description": ""
            //2021-08-04 KMB policy description
        });
        //2021-07-19 KMB 3526  update validity period in years months and days as a text
        updateValidityPeriod(0);
        //2021-07-19 KMB 3526  update validity period in years months and days as a text
    }
    //2021-10-11 KMB 3866 code review  comments
    try {
        //2021-07-30 KMB  updates  policy values as per group configuration
        if (true) {
            //check for secure_type here
            if (r != undefined && r.secure_type == "block") {
                fndisableAdvanceSection();
            } else {

                var policyAttributes = handleGroupConfigurationForPolicyBeforeRendering();
                if (policyAttributes) {
                    updatePolicyUIControls(policyAttributes);
                    //check if any check box  is toggled from product  feature   if it  then override previous values
                    var updatedValues = updatePolicyRuleForFeature(policyAttributes);
                    updatePolicyUIControls(updatedValues);
                }
            }
        }
        //2021-07-30 KMB  updates  policy values as per group configuration
    } catch (e) { }
    //2021-10-11 KMB 3866 code review  comments
}

function copyRules() {
    rulecopy = [];
    for (i = 0; i < ruleJSON.length; i++) {
        //2021-07-19KMB 3526 check if secure_type is present in rule or not
        var add_obj = prepareruleObject(ruleJSON[i],i);
        rulecopy.push(add_obj);
        /*
        rulecopy.push({
            "description": ruleJSON[i].description,
            "rule": ruleJSON[i].rule,
            "ruledata": ruleJSON[i].ruledata,
            "outlook": ruleJSON[i].outlook,
            "gsg": ruleJSON[i].gsg,
            "audit": ruleJSON[i].audit,
            "enabled": ruleJSON[i].enabled,
            "index": i
        });*/
    }
    if (rulecopy.length > 0) {
        $$("pastebuttonForPolicyRules").enable();
        webix.message({ type: "error", text: rulecopy.length.toString() + " rule/s copied" })
    }
    else {
        $$("pastebuttonForPolicyRules").disable();
    }
}

function fnGetUniqueName(name) {
    var bPresent = false;
    for (i = 0; i < ruleJSON.length; i++) {
        //2021-09-02 ignore case while comparing rule
        if (ruleJSON[i].description.toLowerCase() == name.toLowerCase()) {
        //2021-09-02 ignore case while comparing rule
            bPresent = true;
        }
    }
    if (bPresent == true) {
        var nSuf = 1;
        try {
            // Get the last part of the name, if the part is a number, we will increment it
            var pos = name.lastIndexOf(' ');
            if (pos != -1) {
                var strSuffix = name.substring(pos + 1);
                if (strSuffix != undefined && isNaN(strSuffix) == false) {
                    var nV = parseInt(strSuffix);
                    nSuf = nV + 1;
                    name = name.substring(0, pos);
                }
            }
        }
        catch (e) {
            // Do nothing
        }

        // Limit the length of name to 28 characters
        if (name.length > 28) {
            name = name.substring(0, 28);
        }
        name = name + " " + nSuf.toString();
        return fnGetUniqueName(name);
    }
    return name;
}

function pasteRules() {
    var len = rulecopy.length;
    if (len > 0) {
        webix.confirm("Do you want to paste " + len.toString() + " rule/s in this list?", function (result) {
            if (result == true) {
                for (var i = 0; i < rulecopy.length; i++) {
                    var rname = rulecopy[i].description;
                    // Check if the rule name is already present
                    rname = fnGetUniqueName(rname);
                    //2021-07-19 KMB 3526
                    var add_obj = prepareruleObject(rulecopy[i], ruleJSON.length);
                    add_obj["description"] = rname;
                    //2021-07-19 KMB 3526
                    ruleJSON.push(add_obj);
                    /*
                    ruleJSON.push({
                        "description": rname,
                        "rule": rulecopy[i].rule,
                        "ruledata": rulecopy[i].ruledata,
                        "outlook": rulecopy[i].outlook,
                        "gsg": rulecopy[i].gsg,
                        "audit": rulecopy[i].audit,
                        "enabled": rulecopy[i].enabled,
                        "index": ruleJSON.length
                    });*/
                }
                bDirtyFlag = true;
                $$("policyListing").clearAll();
                $$("policyListing").parse(ruleJSON);
            }
        })
    }
    else {
        $$("pastebuttonForPolicyRules").disable();
    }
}

var nCurrentIndex = -1;
var nTableId = -1;
var nRowID = -1;
var ruleJSON = [];



webix.ready(function () {

    webix.ui({ view: "popup", id: "help_email", width: 500, height: 150, head: !1, body: { view: "scrollview", body: { rows: [{ template: "<b>Rule Data<\/b><hr/><b>Email Address<\/b>:<br/>Enter a valid email address<br/>" }] } } });
    webix.ui({ view: "popup", id: "help_text", width: 500, height: 300, head: !1, body: { view: "scrollview", body: { rows: [{ template: "<b>Rule Data<\/b><hr/><b>Text Search<\/b>:<br/>For performing simple text search, enter the text. The search is case insensitive.<br/><br/><b>Regular Expressions<\/b>:<br/>For performing regular expression search enter the search expression prefixed by the word <b>REG:<\/b><br/>For eg.<br/>REG:^[A-Z0-9._%+-]+@[A-Z0-9.-]+.[A-Z]{2,}$<br/>" }] } } });
    webix.ui({ view: "popup", id: "help_key_value", width: 500, height: 300, head: !1, body: { view: "scrollview", body: { rows: [{ template: "<b>Rule Data<\/b><hr/><b>Key:Value<\/b>:<br/>Enter a key:value pair for searching. <br/><br/> For eg.<br/>X-Data:CorporateEmail<br/><br/>" }] } } });


    var form = {
        id: "ruleForm", view: "form", borderless: !0, elements: [
            {
                //2021-07-19 KMB 3526 add two section basic and advance settings, existing settings will move to basic setting section
                rows: [
                    {
                        height: 310,
                        cols: [
                            {
                                //first column
                                view: "fieldset", css:"filedsetstyle",label: "Basic settings", id: "basic_view", body: {
                                    rows: [
                                        { view: "text", label: "Rule Name", name: "description", attributes: { maxlength: 30 }, required: true},
                                        {
                                            //2021-07-19 KMB 3526 change Encrypt if to Rule
                                            view: "select", label: "Rule", name: "rule", options: rule_options, required: true,  on: {
                                                onChange: function (n) {
                                                    var i = this.getFormView();

                                                    t = i.elements.ruledata;
                                                    o = i.elements.outlook;
                                                    g = i.elements.gsg;
                                                    g.enable();
                                                    if (n == 8 || n == 9) {
                                                        t.disable(); t.setValue("");
                                                        o.enable();
                                                    }
                                                    else if (n == 5) {
                                                        o.disable(); o.setValue(0);
                                                    }
                                                    else if (n == 12) {
                                                        t.disable(); t.setValue("");
                                                        o.enable();
                                                        g.disable(); g.setValue(0);
                                                    }
                                                    else {
                                                        t.enable();
                                                        o.enable();
                                                        g.enable();
                                                    }
                                                }
                                            }
                                        },
                                        {
                                            cols: [{ id: "helpbutton", view: "text", label: "Rule Data", name: "ruledata", required: true},
                                            {
                                                view: "icon", width: 20, template: iconInfo, on: {
                                                    onItemClick: function () {
                                                        //var n = this.getParentView().getParentView().getValues();
                                                        //2021-07-19 KMB 3526
                                                        var n = $$("ruleForm").getValues();
                                                        //2021-07-19 KMB 3526
                                                        if (n.rule != 8 && n.rule != 9 && n.rule != 12) {
                                                            if (n.rule == 1 || n.rule == 3) {
                                                                $$("help_email").show(this.$view)
                                                            }
                                                            else if (n.rule == 5 || n.rule == 10) {
                                                                $$("help_key_value").show(this.$view)
                                                            }
                                                            else {
                                                                $$("help_text").show(this.$view)
                                                            }

                                                        }
                                                    }
                                                }
                                            }]
                                        },
                                        {
                                            //2021-09-21 KMB text change for tooltip
                                            cols: [{
                                                view: "checkbox", label: "Clients", name: "outlook", value: 1, tooltip: true, tooltip: "Allow policy matching in Galaxkey Add-in, GWA, Galaxkey on Mac, iOS and Android" },
                                            { view: "checkbox", label: "Secure Gateway", name: "gsg", value: 1 }]
                                        },
                                        {
                                            cols: [{ view: "checkbox", label: "Auditable", name: "audit" },
                                            { view: "checkbox", label: "Enable policy", name: "enabled", value: 1 }]
                                        },
                                        //2021-08-04 KMB add a policy description
                                        {
                                            //add description text
                                            view: "text", label: "Description", name: "ui_description", id: "ui_description", labelPosition: "top", attributes: { maxlength: 300 }
                                        }
                                        //2021-08-04 KMB add a policy description,

                                    ]
                                }
                            },//first column
                            { width: 10 },
                            //2021-07-19 KMB 3526 add new section Advance settings
                            {
                                view: "fieldset", css: "filedsetstyle", label: "Advance settings", id: "advance_view", width: 300, body: {
                                    rows: [
                                        {
                                            cols: [
                                                {
                                                    rows: [
                                                        {
                                                            view: "checkbox", label: "Notification", name: "ui_notification", id:"ui_notification",value: 0},
                                                        {
                                                            view: "checkbox", label: "Forward Block", name: "ui_forwardblock", id:"ui_forwardblock",value: 0},
                                                        {
                                                            view: "checkbox", label: "Reply Block", name: "ui_replyblock", id:"ui_replyblock",value: 0},
                                                        {
                                                            view: "checkbox", label: "Geofence", name: "ui_geofence", id:"ui_geofence", value: 0},
                                                        {
                                                            //2021-09-02 restrict negative values
                                                            view: "text", label: "Validity Period", attributes: { type: "number", min: "1" }, name: "ui_validityperiod", id: "ui_validityperiod", labelPosition: "top", on: {
                                                            //2021-09-02 restrict negative values
                                                                onChange: function (newValue, oldValue, config) {
                                                                    // config is {yourProperty: "yourValue"}
                                                                    updateValidityPeriod(newValue);
                                                                },
                                                                onAfterRender: function () { },
                                                                onTimedKeyPress: function () {
                                                                    updateValidityPeriod($$("ui_validityperiod").getValue());
                                                                },
                                                                onKeyPress: function (code, ev) {
                                                                    if (code == 8 || code == 9) {
                                                                        return true;
                                                                    }
                                                                    if (code < 48 || code > 57) {
                                                                        return webix.html.preventEvent(ev);
                                                                    }
                                                                    if (code >= 48 && code <= 57) {
                                                                        return true;
                                                                    }
                                                                },
                                                                onBlur: function (data) {
                                                                }
                                                            }
                                                        }

                                                    ]
                                                },
                                                {
                                                    rows: [
                                                        {view: "checkbox", label: "Yoti Verification", name: "ui_yotiverification", id:"ui_yotiverification",value: 0},
                                                        {view: "checkbox", label: "Digital Sign", name: "ui_digitalsign", id:"ui_digitalsign", value: 0},
                                                        {view: "checkbox", label: "Authorisation", name: "ui_authorisationrequired", id:"ui_authorisationrequired", value: 0},
                                                        {},
                                                        { view: "label", id: "validitytxt", name: "validitytxt",  readonly: true }
                                                    ]
                                                }
                                            ]
                                        },
                                        {
                                            view: "select", label: "Classification", name: "ui_classification", id:"ui_classification", options: classification_options, on: {
                                                onChange: function (n) {
                                                }
                                            }
                                        }
                                    ]
                                }
                            }//second column
                            //2021-07-19 KMB 3526 add new section Advance settings
                        ]
                    },
                    {
                        height: 100,
                        cols: [
                            {
                                view: "fieldset", css: "filedsetstyle", label: "Actions", id: "action_view", width: 200, body: {
                                    view: "radio", value: "Encrypt", name: "secure_type", id: "secure_type", options: [
                                        { id: "encrypt", value: "Encrypt" }, // the initially selected item
                                        { id: "block", value: "Block" }
                                    ], on: {
                                        onChange: function (newValue, oldValue, config) {
                                            if (newValue == undefined || newValue == "") {
                                            }
                                            if (newValue == "block") {
                                                fndisableAdvanceSection();
                                            }
                                            if (newValue == "encrypt") {
                                                fnenableAdvanceSection();
                                            }
                                        }
                                    }
                                }
                            }, {width:10},
                            {
                            }
                        ]
                    }
                ]
            },
            //2021-07-19 KMB 3526 add two radio button , Encrypt and Block
            {
                cols: [{
                    view: "button", value: "Save", css: "savebtncss", click: function () {
                        //if (this.getParentView().getParentView().validate())
                        if ($$("ruleForm").validate()) {
                            //2021-10-05 KMB #3704
                            //webix.alert("Policy data saved successfully");

                            var n = this.getParentView().getParentView().getValues();
                            n.description = $.trim(n.description);
                            n.description = n.description.replace("&", "&amp;");
                            n.description = n.description.replace("<", "&lt;");
                            n.description = n.description.replace(">", "&gt;");
                            //2021-07-19 KMB 3526 add classification txt and remove validitytxt from object
                            {//check for classification
                                n.ui_classificationtxt = "";
                                //add classification txt here
                                if (n.ui_classification) {
                                    //2021-09-29 KMB 3751
                                    if (n.ui_classification != -1) {
                                        //2021-09-29 KMB 3751
                                        var classTxt = classification_options[n.ui_classification];
                                        n.ui_classificationtxt = classTxt.value;
                                    }
                                }

                                if (n.validitytxt) {
                                    delete n.validitytxt;
                                }

                                //2021-08-04 KMB encode policy description here
                                if (n.ui_description != undefined && n.ui_description != "") {
                                    n.ui_description = Base64.encode(n.ui_description);
                                }
                                //2021-08-04 KMB encode policy description here
                            }
                            //2021-07-19 KMB 3526 add classification txt and remove validitytxt from object

                            if (n.ruledata != undefined && n.ruledata != "") {
                                n.ruledata = Base64.encode(n.ruledata);
                            }
                            else {
                                n.ruledata = "";
                            }
                            if (nCurrentIndex != -1) {
                                n.index = nCurrentIndex;
                                ruleJSON[nCurrentIndex] = n;
                            }
                            else {
                                n.index = ruleJSON.length;
                                ruleJSON.push(n);
                            }
                            bDirtyFlag = true;
                            $$("policyListing").clearAll();
                            $$("policyListing").parse(ruleJSON);
                            //this.getTopParentView().hide();
                            //2021-07-19 KMB 3526
                            $$("RuleDefinitionWin").hide();
                            //2021-07-19 KMB 3526

                        }
                        else {
                            //2021-10-05 KMB #3704
                            if (g_str_message == "") {
                                g_str_message = "Please enter information in the mandatory fields marked with *";
                            }
                            webix.alert({
                                type: "alert-error",
                                title: "Error",
                                text: g_str_message
                            });
                            //webix.message({ type: "error", text: "Form data is invalid" });
                            //2021-10-05 KMB #3704
                        }
                    }
                },
                {
                    view: "button", value: "Cancel", css: "cancelbtncss", click: function () { this.getParentView().getTopParentView().hide() }
                }]
            }], rules: {
            description: function (n) {
                    //2021-10-05 KMB #3704
                    g_str_message = "";
                    //2021-10-05 KMB #3704
                    // Lets trim the rule name
                    n = $.trim(n);
                    n = encodeURIComponent(n);
                    if (n != undefined && n != "") {
                        for (i = 0; i < ruleJSON.length; i++) if (nCurrentIndex != i) {
                            //2021-09-02 ignore case while comparing rule
                            //2021-10-05 KMB #3704
                            var t = ruleJSON[i]; if (encodeURIComponent(t.description).toLowerCase() == n.toLowerCase()) return g_str_message ="The rule name is already defined!",// webix.message({ type: "error", text: "The rule name is already defined!" }),
                                !1
                        }
                        //2021-09-02 ignore case while comparing rule
                        return !0
                    }
                    return !1
                },
                rule: function (n) {
                    return webix.rules.isNumber && n > 0;
                },
                ruledata: function (n) {
                    var bReturn = true;
                    if (n == undefined) {
                        bReturn = false;
                    }
                    if (n == "") {
                        bReturn = false;
                    }
                    // Check if the rule is for email validation then we will do email validation
                    var rule = this.elements.rule.getValue();
                    if (rule == 1 || rule == 3) {
                        //bReturn = (/^['a-zA-Z0-9._-]+@([a-zA-Z0-9.-]+\.)+[a-zA-Z0-9.-]{2,10}$/).test((n || "").toString());
                        //2022-02-10 KMb #4582
                        bReturn = Utility.isValidEmail(n.toString());
                        //2022-02-10 KMb #4582
                    }
                    return bReturn;
                }
            },
        elementsConfig: { labelPosition: "left", labelWidth: 120 }, on: {
            onViewShow: function () {}        }
    };

    //2021-07-19 KMB 3526 change popup width
    webix.ui({ view: "window", id: "RuleDefinitionWin", width: 900, height: 700, position: "center", modal: !0, head: "Policy Rule Definition", body: webix.copy(form) });
    //2021-07-19 KMB 3526 change popup width

    if ($("#policymanager").length > 0) {
        var policyGrid = webix.ui({
            container: "policymanager",
            rows: [
                {
                    view: "toolbar",
                    id: "ruleToolbar", height: 42,
                    cols: [
                        { view: "label", type: "icon", label: "Encryption Rules", width: 150, align: "left" },
                        { gravity: 2 },
                        { id: "pastebuttonForPolicyRules", view: "button", type: "icon", icon: "paste", label: "Paste", click: "pasteRules();", disabled: true },
                        { id: "copybuttonForPolicyRules", view: "button", type: "icon", icon: "copy", label: "Copy all", click: "copyRules();" },
                        { view: "button", type: "icon", icon: "plus", label: "Add new", click: "nCurrentIndex=-1;showFormRule('RuleDefinitionWin', ruleJSON, -1)" }
                    ]
                },
                {
                    id: 'policyListing',
                    autoheight: true,
                    autowidth: true,
                    view: "datatable",
                    columns: [
                        { id: "description", header: "Rule Name", width: 200 },
                        { id: "status", header: "Status", width: 55, template: function (obj) { return (obj.enabled == 1) ? "Active" : "Inactive"; }, css: { "text-align": "center" } },
                            //2021-09-24 KMB #3737
                        { id: "outlook", header: "Clients", width: 70, template: function (obj) { return (obj.outlook == 1) ? "&#10003;" : ""; }, css: { "text-align": "center" } },
                            //2021-09-24 KMB #3737
                        { id: "gsg", header: "Secure Gateway", width: 70, template: function (obj) { return (obj.gsg == 1) ? "&#10003;" : ""; }, css: { "text-align": "center" } },
                        { id: "audit", header: "Auditable", width: 75, template: function (obj) { return (obj.audit == 1) ? "&#10003;" : ""; }, css: { "text-align": "center" } },
                        { id: "action", header: "", width: 80, template: iconCopy + iconDelete + iconEditplicy, css: { "text-align": "center" } }
                    ],
                    onClick: {
                        "ruleedit1": function (e, id) {
                            nCurrentIndex = this.getItem(id).index;
                            showFormRule("RuleDefinitionWin", ruleJSON, this.getItem(id).index);
                        },
                        "fa-copy": function (e, id) {
                            nCurrentIndex = this.getItem(id).index;
                            rulecopy = [];
                            //2021-07-19 3526 KMB
                            var add_obj = prepareruleObject(ruleJSON[nCurrentIndex], 0);
                            rulecopy.push(add_obj);
                            //2021-07-19 3526 KMB
                            /*
                            rulecopy.push({
                                "description": ruleJSON[nCurrentIndex].description,
                                "rule": ruleJSON[nCurrentIndex].rule,
                                "ruledata": ruleJSON[nCurrentIndex].ruledata,
                                "outlook": ruleJSON[nCurrentIndex].outlook,
                                "gsg": ruleJSON[nCurrentIndex].gsg,
                                "audit": ruleJSON[nCurrentIndex].audit,
                                "enabled": ruleJSON[nCurrentIndex].enabled,
                                "index": 0
                            });*/
                            if (rulecopy.length > 0) {
                                $$("pastebuttonForPolicyRules").enable();
                                webix.message({ type: "error", text: "One rule copied" })
                            }
                            else {
                                $$("pastebuttonForPolicyRules").disable();
                            }
                        },
                        "fa-trash": function (e, id) {
                            nTableId = this.getItem(id).index;
                            nRowID = id;
                            webix.confirm("Do you want to delete the rule: " + this.getItem(id).description + "?", function (result) {
                                if (result == true) {
                                    for (var i = ruleJSON.length - 1; i >= 0; i--) {
                                        if (ruleJSON[i].index == nTableId) {
                                            ruleJSON.splice(i, 1);
                                            $$("policyListing").remove(nRowID);
                                            break;
                                        }
                                    }
                                    // Update the index
                                    for (var i = ruleJSON.length - 1; i >= 0; i--) {
                                        ruleJSON[i].index = i;
                                    }
                                    bDirtyFlag = true;
                                }
                            })
                        }

                    }
                }
            ]
        });

        $$("policyListing").parse(ruleJSON);
    }
});



//2021-07-19KMB 3526 read classification data from viewbag
// convert days into years months and days
function updateValidityPeriod(d) {
    if (d == undefined || d == "") {
        $$("validitytxt").setValue("");
        return;
    }

    let months = 0, years = 0, days = 0, weeks = 0
    if (d == 0 ) {
        $$("validitytxt").setValue("");
        return;
    }
    //2021-09-02 restrict negative values
    if (d <= 0) {
        //if negative  return  from here
        return;
    }
    while (d) {
        if (d >= 365) {
            years++;
            d -= 365;
        } else if (d >= 30) {
            months++;
            d -= 30;
        } else {
            days++;
            d--;
        }
    };
    var txt = "";
    if (years > 0)
        if (years > 1)
            txt = years + " years ";
        else
            txt = years + " year ";

    if (months > 0)
        if (months > 1)
            txt = txt + months + " months ";
        else
            txt = txt + months + " month ";


    if (days > 0)
        if (days > 1)
            txt = txt + days + " days ";
        else
            txt = txt + days + " day ";
    $$("validitytxt").setValue(txt);

}

$(document).ready(function () {
    //seee if classification data is present
    try {
        fnLoadClassificationJsonData(strClassficationData);
    } catch (e) { }
});

//2021-09-29 KMB 3751 add no selected classification
function fnNotSelectedClassfication() {

    var row = {};
    row["default"] = "0";
    row["id"] = -1;
    row["index"] = "-1";
    row["value"] = "Select Classification";
    return row;
}
//2021-09-29 KMB 3751 add no selected classification
function fnLoadClassificationJsonData(strData) {
    try {
        if (strData != "") {
            var decodedData = Base64.decode(strData);
            var d = JSON.parse(decodedData);
            classification_options = d;

            //2021-08-06 KMB get default classification index
            var len = d.length;
            for (var i = 0; i < len;i++) {
                var elm = d[i];
                if (elm.default == "1") {
                    g_default_classification_value = elm.index;
                }
            }
            //2021-08-06 KMB get default classification index
        }

        //2021-09-29 KMB 3751 add no selected classification
        classification_options.push(fnNotSelectedClassfication());
        //2021-09-29 KMB 3751 add no selected classification
        g_default_classification_value = "-1";
    } catch (e) { }
}
//this function returns rule object, if new parameters are not present in rule object, it adds them with default values
function prepareruleObject(rule, i) {
    var add_obj = {};
    if (rule.secure_type === undefined || rule.secure_type === "") {

        add_obj["description"] = rule.description;
        add_obj["rule"] = rule.rule;
        add_obj["ruledata"] = rule.ruledata;
        add_obj["outlook"] = rule.outlook;
        add_obj["gsg"] = rule.gsg;
        add_obj["audit"] = rule.audit;
        add_obj["enabled"] = rule.enabled;
        add_obj["index"] = i;

        add_obj["secure_type"] = "encrypt";
        add_obj["ui_authorisationrequired"] = 0;
        //2021-09-29 KMB 3751
        add_obj["ui_classification"] = -1;
        //2021-09-29 KMB 3751
        add_obj["ui_digitalsign"] = 0;
        add_obj["ui_forwardblock"] = 0;
        add_obj["ui_geofence"] = 0;
        add_obj["ui_notification"] = 0;
        add_obj["ui_replyblock"] = 0;
        add_obj["ui_validityperiod"] = "";
        add_obj["ui_yotiverification"] = 0;
        add_obj["validitytxt"] = "";
        //2021-08-04 KMB add policy description
        add_obj["ui_description"] = "";
        //2021-08-04 KMB add policy description
    }
    else {

        add_obj["description"] = rule.description;
        add_obj["rule"] = rule.rule;
        add_obj["ruledata"] = rule.ruledata;
        add_obj["outlook"] = rule.outlook;
        add_obj["gsg"] = rule.gsg;
        add_obj["audit"] = rule.audit;
        add_obj["enabled"] = rule.enabled;
        add_obj["index"] = i;

        add_obj["secure_type"] = rule.secure_type;
        add_obj["ui_authorisationrequired"] = rule.ui_authorisationrequired;
        add_obj["ui_classification"] = rule.ui_classification;
        add_obj["ui_digitalsign"] = rule.ui_digitalsign;
        add_obj["ui_forwardblock"] = rule.ui_forwardblock;
        add_obj["ui_geofence"] = rule.ui_geofence;
        add_obj["ui_notification"] = rule.ui_notification;
        add_obj["ui_replyblock"] = rule.ui_replyblock;
        add_obj["ui_validityperiod"] = rule.ui_validityperiod;
        add_obj["ui_yotiverification"] = rule.ui_yotiverification;
        add_obj["validitytxt"] = "";
        //2021-08-04 KMB add policy description
        add_obj["ui_description"] = rule.ui_description;
        //2021-08-04 KMB add policy description
    }
    return add_obj;
}
//2021-07-19KMB 3526 read classification data from viewbag

//2021-07-29 KMB policy engine shall  checl for  group configuration checks

function updatePolicyUIControls(policyAttribDict) {
    if (policyAttribDict) {

        //if secure send  mail is off then disable following controls
        //secure type  radio button
        //authorisation check box
        //check if secure type is enabled
        if (policyAttribDict["secure_type"] == true) {
            $$("secure_type").enable();
            $$("advance_view").enable();
            if (policyAttribDict["ui_authorisationrequired"] == false) {
                $$("ui_authorisationrequired").disable();
            }
            else {
                $$("ui_authorisationrequired").enable();
            }
        }
        else {
            //disable radio control
            $$("secure_type").disable();
            $$("ui_authorisationrequired").disable();
            $$("advance_view").disable();
        }

        //check if digitalsign
        if (policyAttribDict["ui_digitalsign"] == true) {
            $$("ui_digitalsign").enable();
        }
        else {

            $$("ui_digitalsign").disable();
        }

        //check if yotiverification
        if (policyAttribDict["ui_yotiverification"] == true) {
            $$("ui_yotiverification").enable();
        }
        else {

            $$("ui_yotiverification").disable();
        }

        //check if ui_notification
        if (policyAttribDict["ui_notification"] == true) {
            $$("ui_notification").enable();
        }
        else {
            $$("ui_notification").disable();
        }

        //check if ui_classification
        if (policyAttribDict["ui_classification"] == true) {
            $$("ui_classification").enable();
        }
        else {

            $$("ui_classification").disable();
        }

        //check if ui_forwardblock
        if (policyAttribDict["ui_forwardblock"] == true) {
            $$("ui_forwardblock").enable();
        }
        else {

            $$("ui_forwardblock").disable();
        }

        //check if ui_replyblock
        if (policyAttribDict["ui_replyblock"] == true) {
            $$("ui_replyblock").enable();
        }
        else {

            $$("ui_replyblock").disable();
        }

        //checkif ui_validityperiod
        if (policyAttribDict["ui_validityperiod"] == true) {
            $$("ui_validityperiod").enable();
        }
        else {

            $$("ui_validityperiod").disable();
        }

        //2021-09-02 handle geofence case
        //for  geofence
        if (policyAttribDict["ui_geofence"] == true) {
            $$("ui_geofence").enable();
        }
        else {
            $$("ui_geofence").disable();
        }
        updatePolicyValues(policyAttribDict);
    }
}
//2022-04-23 KMB quick fix for policy not showing saved values in the ui #4994
function fnGetFeatureStatusAcrosstheProducts() {
    var parray = [];
    try {
        if (gGroupJSONDataObj) {
            if (gGroupJSONDataObj.products) {
                gGroupJSONDataObj.products.forEach((elem, index, array) => {
                    elem.features.forEach((elem2, index2, array2) => {
                        let ispresent = parray.find(obj => obj.code == elem2.code);
                        if (ispresent == undefined || ispresent == null) {
                            //add object here
                            parray.push(elem2);
                        }
                        else {
                            //if present check what is value
                            if (elem2.bEnabledForTheGroup == "True") {
                                ispresent.bEnabledForTheGroup = "True";
                            }
                        }
                    });
                });
            }
        }
    }
    catch (e) {

    }
    return parray;
}
//2022-04-23 KMB quick fix for policy not showing saved values in the ui #4994
//function handleGroupConfigurationForPolicyBeforeRendering()
//{
//    var policyAttributesDict = {};

//    policyAttributesDict["secure_type"] = false;
//    policyAttributesDict["ui_authorisationrequired"] = false;
//    policyAttributesDict["ui_classification"] = false;
//    policyAttributesDict["ui_digitalsign"] = false;
//    policyAttributesDict["ui_forwardblock"] = false;
//    policyAttributesDict["ui_geofence"] = false;
//    policyAttributesDict["ui_notification"] = false;
//    policyAttributesDict["ui_replyblock"] = false;
//    policyAttributesDict["ui_validityperiod"] = false;
//    policyAttributesDict["ui_yotiverification"] = false;

//    var L1Ext = getL1ExtendedConfig();
//    console.log("L1Ext=", L1Ext);
//    if (gGroupJSONDataObj) {
//        if (gGroupJSONDataObj.products) {
//            console.log("gGroupJSONDataObj.products", gGroupJSONDataObj.products);
//            if (gGroupJSONDataObj.products.length > 0) {
//                var features = gGroupJSONDataObj.products[0].features;
//                console.log("features", features);
//                if (features != null) {
//                    features.forEach((elem, index, array) => {
//                        //send secure  emails L1 if  enable  then enable encrypt/block radio or else  disable  them and  default value=encrypt
//                        if (elem.code == "L1") {
//                            policyAttributesDict["secure_type"] = isenableAttribute(elem, "L1");
//                            //ui_authorisationrequired  check for L1F19
//                            if (policyAttributesDict["secure_type"] == true) {
//                                if (L1Ext) {
//                                    if (L1Ext.L1F9)
//                                    {
//                                        if (L1Ext.L1F9.toLowerCase() == 'true') {
//                                            policyAttributesDict["ui_authorisationrequired"] = true;
//                                        }
//                                    }
//                                }
//                            }
//                        }
//                        //mail timeout
//                        if (elem.code == "L2") {
//                            //mail timeout  L2
//                            policyAttributesDict["ui_validityperiod"] = isenableAttribute(elem, "L2");
//                        }

//                        if (elem.code == "L4") {
//                            //notifications L4
//                            policyAttributesDict["ui_notification"] = isenableAttribute(elem, "L4");
//                            console.log(policyAttributesDict["ui_notification"]);
//                        }

//                        if (elem.code == "L8") {
//                            //classification L8
//                            policyAttributesDict["ui_classification"] = isenableAttribute(elem, "L8");
//                        }
//                         //2021-09-21 KMB #3709
//                        if (elem.code == "L5") {
//                            //mail digital sign L5
//                            policyAttributesDict["ui_digitalsign"] = isenableAttribute(elem, "L5");
//                        }
//                         //2021-09-21 KMB #3709
//                        //Authorised data distribution L10
//                        if (elem.code == "L10") {
//                            //mail timeout  L10 forward  and reply back
//                            policyAttributesDict["ui_forwardblock"] = isenableAttribute(elem, "L10");

//                            policyAttributesDict["ui_replyblock"] = isenableAttribute(elem, "L10");
//                        }
//                        //geofence
//                        //2021-09-02 handle geofence case
//                        if (elem.code == "L13") {
//                            //digital sign L13
//                            policyAttributesDict["ui_geofence"] = isenableAttribute(elem, "L13");
//                        }
//                        //2021-09-15 KMB fixed yoti verification code
//                        if (elem.code == "L26") {
//                            //Yoti L26
//                            policyAttributesDict["ui_yotiverification"] = isenableAttribute(elem, "L26");
//                        }
//                    });
//                }
//            }
//        }
//    }
//    console.log("ret=", policyAttributesDict);
//    return policyAttributesDict;
//}

function handleGroupConfigurationForPolicyBeforeRendering() {

    var policyAttributesDict = {};

    policyAttributesDict["secure_type"] = false;
    policyAttributesDict["ui_authorisationrequired"] = false;
    policyAttributesDict["ui_classification"] = false;
    policyAttributesDict["ui_digitalsign"] = false;
    policyAttributesDict["ui_forwardblock"] = false;
    policyAttributesDict["ui_geofence"] = false;
    policyAttributesDict["ui_notification"] = false;
    policyAttributesDict["ui_replyblock"] = false;
    policyAttributesDict["ui_validityperiod"] = false;
    policyAttributesDict["ui_yotiverification"] = false;

    var L1Ext = getL1ExtendedConfig();
    if (gGroupJSONDataObj) {
        if (gGroupJSONDataObj.products) {
            if (gGroupJSONDataObj.products.length > 0) {
                //2022-04-23 KMB quick fix for policy not showing saved values in the ui #4994
                let features = fnGetFeatureStatusAcrosstheProducts();
                //2022-04-23 KMB quick fix for policy not showing saved values in the ui #4994
                if (features != null) {
                    features.forEach((elem, index, array) => {
                        //send secure  emails L1 if  enable  then enable encrypt/block radio or else  disable  them and  default value=encrypt
                        if (elem.code == "L1") {
                            policyAttributesDict["secure_type"] = isenableAttribute(elem, "L1");
                            //ui_authorisationrequired  check for L1F19
                            if (policyAttributesDict["secure_type"] == true) {
                                if (L1Ext) {
                                    if (L1Ext.L1F9) {
                                        if (L1Ext.L1F9.toLowerCase() == 'true') {
                                            policyAttributesDict["ui_authorisationrequired"] = true;
                                        }
                                    }
                                }
                            }
                        }
                        //mail timeout
                        if (elem.code == "L2") {
                            //mail timeout  L2
                            policyAttributesDict["ui_validityperiod"] = isenableAttribute(elem, "L2");
                        }

                        if (elem.code == "L4") {
                            //notifications L4
                            policyAttributesDict["ui_notification"] = isenableAttribute(elem, "L4");
                        }

                        if (elem.code == "L8") {
                            //classification L8
                            policyAttributesDict["ui_classification"] = isenableAttribute(elem, "L8");
                        }
                        //2021-09-21 KMB #3709
                        if (elem.code == "L5") {
                            //mail digital sign L5
                            policyAttributesDict["ui_digitalsign"] = isenableAttribute(elem, "L5");
                        }
                        //2021-09-21 KMB #3709
                        //Authorised data distribution L10
                        if (elem.code == "L10") {
                            //mail timeout  L10 forward  and reply back
                            policyAttributesDict["ui_forwardblock"] = isenableAttribute(elem, "L10");

                            policyAttributesDict["ui_replyblock"] = isenableAttribute(elem, "L10");
                        }
                        //geofence
                        //2021-09-02 handle geofence case
                        if (elem.code == "L13") {
                            //digital sign L13
                            policyAttributesDict["ui_geofence"] = isenableAttribute(elem, "L13");
                        }
                        //2021-09-15 KMB fixed yoti verification code
                        if (elem.code == "L26") {
                            //Yoti L26
                            policyAttributesDict["ui_yotiverification"] = isenableAttribute(elem, "L26");
                        }
                    });
                }
            }
        }
    }
    return policyAttributesDict;
}
function isenableAttribute(elem, checkwith) {
    if (elem) {
        if (elem.code== checkwith) {
            if (elem.bEnabledForTheGroup=="False")
                return false;
        }
    }
    return true;
}

function getL1ExtendedConfig() {
    if (gGroupJSONDataObj) {
        if (gGroupJSONDataObj.feature_extended_conf_data) {
            var decodedData = Base64.decode(gGroupJSONDataObj.feature_extended_conf_data);
            var jObj = JSON.parse(decodedData);
            return jObj.L1;
        }
    }
}

function updatePolicyValues(policyAttribDict) {

    var policyValues = $$("ruleForm").getValues();
    if (policyAttribDict) {

        //if secure send  mail is off then disable following controls
        //secure type  radio button
        //authorisation check box
        //check if secure type is enabled
        if (policyAttribDict["secure_type"] == true) {

            if (policyAttribDict["ui_authorisationrequired"] == false) {

                policyValues.ui_authorisationrequired = 0;
            }
        }
        else {

            //set value  to block
            //disable
            //$$("secure_type").disable();
            //$$("ui_authorisationrequired").disable();
            policyValues.secure_type = "block";
            policyValues.ui_authorisationrequired = 0;
        }

        //check if digitalsign
        if (policyAttribDict["ui_digitalsign"] == true) {

        }
        else {

            policyValues.ui_digitalsign = 0;
        }

        //check if yotiverification
        if (policyAttribDict["ui_yotiverification"] == true) {

        }
        else {
            policyValues.ui_yotiverification = 0;
        }

        //check if ui_notification
        if (policyAttribDict["ui_notification"] == true) {

        }
        else {
            policyValues.ui_notification = 0;
        }

        //check if ui_classification
        if (policyAttribDict["ui_classification"] == true) {

        }
        else {
            policyValues.ui_classification = 0;
        }

        //check if ui_forwardblock
        if (policyAttribDict["ui_forwardblock"] == true) {

        }
        else {

            policyValues.ui_forwardblock = 0;
        }

        //check if ui_replyblock
        if (policyAttribDict["ui_replyblock"] == true) {

        }
        else {
            policyValues.ui_replyblock = 0;
        }

        //check if geofence ui_geofence
        //2021-09-02 handle geofence case
        if (policyAttribDict["ui_geofence"] == true) {

        }
        else {

            policyValues.ui_geofence = 0;
        }

        //checkif ui_validityperiod
        if (policyAttribDict["ui_validityperiod"] == true) {

        }
        else {
            policyValues.ui_validityperiod = "";
            policyValues.validitytxt = "";
        }
    }
    $$("ruleForm").setValues(policyValues);
}

function updatePolicyRuleForFeature(policyAttribDict) {
    if (gUpdatePolicyRule) {
         {
            if (gUpdatePolicyRule.L1 == true) {
                //check if authorisation is  enable or  not
                policyAttribDict["ui_authorisationrequired"] = $("#L1F9").prop("checked");
            }
            else {
                //L! means  secure type  set to block
                policyAttribDict["secure_type"] = false;
            }

            //L2 means timeout
            policyAttribDict["ui_validityperiod"] = false;
            if (gUpdatePolicyRule.L2) {
                if (gUpdatePolicyRule.L2 == true) {
                    policyAttribDict["ui_validityperiod"] = true;
                }
                else {
                    //L2 means timeout
                    policyAttribDict["ui_validityperiod"] = false;
                }
            }
            //L2 means timeout

            //L4 means notification
            policyAttribDict["ui_notification"] = false;
            if (gUpdatePolicyRule.L4) {
                if (gUpdatePolicyRule.L4 == true) {
                    policyAttribDict["ui_notification"] = true;
                }
                else {
                    //L4 means notification
                    policyAttribDict["ui_notification"] = false;
                }
            }
            //L4 means notification

            //L8 means classification
            policyAttribDict["ui_classification"] = false;
            if (gUpdatePolicyRule.L8) {
                if (gUpdatePolicyRule.L8 == true) {
                    policyAttribDict["ui_classification"] = true;
                }
                else {
                    //L8 means classification
                    policyAttribDict["ui_classification"] = false;
                }
            }
            //L8 means classification
            //2021-09-21 KMB #3709
            //L45 means mail digital sign
            policyAttribDict["ui_digitalsign"] = false;
            if (gUpdatePolicyRule.L5) {
                if (gUpdatePolicyRule.L5 == true) {
                    policyAttribDict["ui_digitalsign"] = true;
                }
                else {
                    //L5 means mail digital sign
                    policyAttribDict["ui_digitalsign"] = false;
                }
            }
            //L5 means mail Digital sign
             //2021-09-21 KMB #3709
            //L10 means  Authorised data  distribution
            if (gUpdatePolicyRule.L10) {
                if (gUpdatePolicyRule.L10 == true) {
                    policyAttribDict["ui_forwardblock"] = true;
                    policyAttribDict["ui_replyblock"] = true;
                }
                else {
                    //L10 means  Authorised data  distribution
                    policyAttribDict["ui_forwardblock"] = false;
                    policyAttribDict["ui_replyblock"] = false;
                }
            }
            else {
                //L10 means  Authorised data  distribution
                policyAttribDict["ui_forwardblock"] = false;
                policyAttribDict["ui_replyblock"] = false;
            }

            //for geofence ui_geofence
            policyAttribDict["ui_geofence"] = false;
            if (gUpdatePolicyRule.L13) {
                if (gUpdatePolicyRule.L13 == true) {
                    policyAttribDict["ui_geofence"] = true;
                }
            }
            //for geofence ui_geofence

            policyAttribDict["ui_yotiverification"] = false;
            //2021-09-15 KMB fixed yoti verification code
            if (gUpdatePolicyRule.L26) {
                if (gUpdatePolicyRule.L26 == true) {
                    policyAttribDict["ui_yotiverification"] = true;
                }
                else {
                    //L10 means  Authorised data  distribution
                    policyAttribDict["ui_yotiverification"] = false;
                }
            }
        }
    }
    return policyAttribDict;
}

function toggle_all_policy_values(flag) {

    var existing_policy_values = $$("ruleForm").getValues();
    var ruleObj = ruleJSON[existing_policy_values.index];
    if (flag == false) {
        if (existing_policy_values) {

            existing_policy_values.secure_type = "block";
            existing_policy_values.ui_authorisationrequired = 0;
            existing_policy_values.ui_classification = 0;
            existing_policy_values.ui_digitalsign = 0;
            existing_policy_values.ui_forwardblock = 0;
            existing_policy_values.ui_geofence = 0;
            existing_policy_values.ui_notification = 0;
            existing_policy_values.ui_replyblock = 0;
            existing_policy_values.ui_validityperiod = "";
            existing_policy_values.ui_yotiverification = 0;
            existing_policy_values.validitytxt = "";

            $$("ruleForm").setValues(existing_policy_values);
        }
    }
    else {
        //read data from ruleJSON
        existing_policy_values.secure_type = "encrypt";

        if (ruleObj) {

            if ($$("ui_authorisationrequired").isEnabled()) {
                existing_policy_values.ui_authorisationrequired = ruleObj.ui_authorisationrequired;
            }
            if ($$("ui_classification").isEnabled()) {
                existing_policy_values.ui_classification = ruleObj.ui_classification;
            }
            if ($$("ui_digitalsign").isEnabled()) {
                existing_policy_values.ui_digitalsign = ruleObj.ui_digitalsign;
            }
            if ($$("ui_forwardblock").isEnabled()) {
                existing_policy_values.ui_forwardblock = ruleObj.ui_forwardblock;
            }
            if ($$("ui_geofence").isEnabled()) {
                existing_policy_values.ui_geofence = ruleObj.ui_geofence;
            }

            if ($$("ui_notification").isEnabled()) {
                existing_policy_values.ui_notification = ruleObj.ui_notification;
            }

            if ($$("ui_replyblock").isEnabled()) {
                existing_policy_values.ui_replyblock = ruleObj.ui_replyblock;
            }

            if ($$("ui_validityperiod").isEnabled()) {
                existing_policy_values.ui_validityperiod = ruleObj.ui_validityperiod;
                updateValidityPeriod(ruleObj.ui_validityperiod);
            }
            if ($$("ui_yotiverification").isEnabled()) {
                existing_policy_values.ui_yotiverification = ruleObj.ui_yotiverification;
            }
        }
        $$("ruleForm").setValues(existing_policy_values);
    }
}
function fndisableAdvanceSection() {
    $$("advance_view").disable();
    toggle_all_policy_values(false);
}

function fnenableAdvanceSection() {
    $$("advance_view").enable();
    toggle_all_policy_values(true);
}