﻿
var strGetGroupData = "";
var strAddGroup = "";
var strDeleteGroup = "";
var strUpdateGroupPolicy = "";



function fnLoadGroupData(strGroupName) {
    // Create overlay and append to body:
    $('<div id="overlay"/>').css({
        position: 'fixed',
        top: 0,
        left: 0,
        width: '100%',
        height: $(window).height() + 'px',
        background: 'white url(/Content/img/galaxkey_whitebk_ani.gif) no-repeat center',
        opacity: 0.90
    }).hide().appendTo('body');

    // SHOW overlay
    $('#overlay').show();
    $.ajax({
        cache: false,
        url: strGetGroupData,
        data: { strGroupName: strGroupName },
        type: 'GET',
        success: function (data) {
            $('#overlay').hide();

            if (data != '') {
                var jSon = JSON.parse([data]);
                var bResult = Boolean(eval(jSon['result']));
                if (bResult == true) {
                    var strJsonText = jSon['message'];

                    fnLoadJsonData(strJsonText);
                    strSelectedGroup = strGroupName;
                }
                else {
                    webix.alert({
                        title: "Group Update Error",
                        ok: "OK",
                        text: jSon['message']
                    });
                }
            }
            else {
                webix.alert({
                    title: "Group Update Error",
                    ok: "OK",
                    text: ' Unable to get the data for the group. Please logout and login again'
                });
            }

        },
        error: function (XMLHttpRequest, textStatus, errorThrown) {
            webix.alert({
                title: "Group Update Error",
                ok: "OK",
                text: "Status: " + textStatus + "Error: " + errorThrown
            });
        },
        complete: function () {
            // Hide the processing gif
            $('#overlay').hide();
        }
    });
};

function fnAddGroup() {

    //2021-06-15 KMB fix pen results
    var form = $('#__AjaxAntiForgeryForm');
    var token = $('input[name="__RequestVerificationToken"]', form).val();



    var form1 = {
        id: "groupName", view: "form", borderless: !0, elements: [{ view: "text", label: "Group Name", name: "Group Name", attributes: { maxlength: 25 } }
            , {
            cols: [{
                view: "button", value: "Create", click: function () {
                    var dialogWindow = this.getTopParentView();
                    var n = this.getParentView().getParentView().getValues();

                    strGroupName = n["Group Name"];

                    // Create overlay and append to body:
                    $('<div id="overlay"/>').css({
                        position: 'fixed',
                        top: 0,
                        left: 0,
                        width: '100%',
                        height: $(window).height() + 'px',
                        background: 'white url(/Content/img/galaxkey_whitebk_ani.gif) no-repeat center',
                        opacity: 0.90
                    }).hide().appendTo('body');

                    // SHOW overlay
                    $('#overlay').show();
                    $.ajax({
                        cache: false,
                        url: strAddGroup,
                        //2021-06-15 KMB fix pen results
                        data: { strGroupName: strGroupName, __RequestVerificationToken: token },
                        type: 'POST',
                        success: function (data) {
                            if (data != '') {
                                $('#overlay').hide();
                                var jSon = JSON.parse([data]);
                                var bResult = Boolean(eval(jSon['result']));
                                if (bResult == true) {
                                    // Lets add the new group to the list of groups
                                    var x = document.getElementById("group_selectable");
                                    var option = document.createElement("option");
                                    option.text = strGroupName;
                                    option.value = strGroupName;
                                    x.add(option);
                                    $("#group_selectable").val(strGroupName);
                                    fnLoadGroupData(strGroupName);
                                }
                                else {
                                    webix.alert({
                                        title: "Group Addition Error",
                                        ok: "OK",
                                        text: jSon['message']
                                    });
                                }
                            }

                        },
                        complete: function () {
                            // Hide the processing gif
                            $('#overlay').hide();
                            dialogWindow.hide();
                        }
                    });
                }
            },
            {
                view: "button", value: "Cancel", click: function () { this.getParentView().getTopParentView().hide() }
            }]
        }]
        , elementsConfig: { labelPosition: "left", labelWidth: 120 }
    };

    webix.ui({ view: "window", id: "GroupDefinitionWin", width: 500, position: "center", modal: !0, head: "Add New Group", body: webix.copy(form1) }).show();



};

function fnDeleteGroup() {

    //2021-06-15 KMB fixed pen results
    var form = $('#__AjaxAntiForgeryForm');
    var token = $('input[name="__RequestVerificationToken"]', form).val();
    // OUK 28/07/2021 3562 UCL
    strSelectedGroup = $('#group_selectable').val();
    var strGroupName = strSelectedGroup;
    // Create overlay and append to body:
    $('<div id="overlay"/>').css({
        position: 'fixed',
        top: 0,
        left: 0,
        width: '100%',
        height: $(window).height() + 'px',
        background: 'white url(/Content/img/galaxkey_whitebk_ani.gif) no-repeat center',
        opacity: 0.90
    }).hide().appendTo('body');

    // SHOW overlay
    $('#overlay').show();
    $.ajax({
        cache: false,
        url: strDeleteGroup,
        //2021-06-15 KMB fix pen results
        data: { strGroupName: strGroupName, __RequestVerificationToken: token},
        type: 'POST',
        success: function (data) {
            $('#overlay').hide();
            if (data != '') {
                var jSon = JSON.parse([data]);
                var strResult = jSon['result'];
                if (Boolean(eval(strResult.toLowerCase())) == true) {
                    // Lets remove new group to the list of groups
                    $("#group_selectable option[value='" + strSelectedGroup + "']").remove();
                    $("#group_selectable").val("DEFAULT GROUP");
                    fnLoadGroupData("DEFAULT GROUP");
                }
                else {
                    webix.alert({
                        title: "Group Deletion Error",
                        ok: "OK",
                        text: jSon['message']
                    });
                }
            }
        },
        complete: function () {
            // Hide the processing gif
            $('#overlay').hide();
        }
    });
};

// This function loads the JSON data in the controls
function fnUpdateGroupPolicy() {
    if (strSelectedGroup != undefined) {
        if (strSelectedGroup != '') {
            // OUK 28/07/2021 3562 UCL
            strSelectedGroup = $('#group_selectable').val();
            var strGroupName = strSelectedGroup;
            // Create overlay and append to body:
            $('<div id="overlay"/>').css({
                position: 'fixed',
                top: 0,
                left: 0,
                width: '100%',
                height: $(window).height() + 'px',
                background: 'white url(/Content/img/galaxkey_whitebk_ani.gif) no-repeat center',
                opacity: 0.90
            }).hide().appendTo('body');


            var changeJSONString = JSON.stringify(changeJSON);
            var strFeaturesJSON = fnGetFeaturesJSON();

            var jSonData = {
                user_group: strSelectedGroup
                , change: Base64.encode(changeJSONString)
                , feature_xml: Base64.encode(strFeaturesJSON)
            };

            // SHOW overlay
            $('#overlay').show();
            $.ajax({
                cache: false,
                url: strUpdateGroupPolicy,
                data: jSonData,
                type: 'POST',
                success: function (data) {
                    $('#overlay').hide();
                    if (data != '') {
                        var jSon = JSON.parse(data);
                        var strResult = jSon['result'];
                        if (Boolean(eval(strResult.toLowerCase())) == false) {
                            webix.alert({
                                title: "Group Policy Update Error",
                                ok: "OK",
                                text: jSon['message']
                            });
                        }
                        else {
                            var options = {};
                            options['closeButton'] = true;
                            options['positionClass'] = "toast-top-center";
                            options['type'] = "success";
                            var title = "";
                            toastr[options.type]("Group Policy Updated", title, options);
                            bDirtyFlag = false;
                        }
                    }
                },
                complete: function () {
                    // Hide the processing gif
                    $('#overlay').hide();
                }
            });
        }
    }
};

function updateTips(t) {
    $(".validateTips")
        .text(t)
        .addClass("ui-state-highlight");
    setTimeout(function () {
        $(".validateTips").removeClass("ui-state-highlight", 1500);
    }, 500);
};

function checkLength(o, n, min, max) {
    if (o.val().length > max || o.val().length < min) {
        o.addClass("ui-state-error");
        updateTips("Length of " + n + " must be between " +
            min + " and " + max + ".");
        return false;
    } else {
        return true;
    }
};

function checkRegexp(o, regexp, n) {
    if (!(regexp.test(o.val()))) {
        o.addClass("ui-state-error");
        updateTips(n);
        return false;
    } else {
        return true;
    }
};

$(document).ready(function () {

    $('#addGroup').click(function () {
        fnAddGroup();
    });

    $('#deleteGroup').click(function () {
        webix.modalbox({
            title: "Group Deletion",
            buttons: ["Yes", "No"],
            text: "Do you want to delete the selected group?",
            width: 500,
            callback: function (result) {
                switch (result) {
                    case "0":
                        fnDeleteGroup();
                        break;
                    case "1":
                        //statement
                        break;
                }
            }
        });
    });

    $('#updatePolicy').click(function () {
        fnUpdateGroupPolicy();
    });

    //2020-09-04 RJS 1883
    $(document).on('click', '#L11F25', function (e) {
        fnProcessL1125();
    });

    function fnProcessL1125() {
        try {
            if ($("#L11F25") != undefined && $("#L11F25").prop('checked') != undefined) {
                var $bChecked = $("#L11F25").prop('checked');
                if ($bChecked == true) {
                    $("#largefileupload").show();
                    //$("#L11F26").val('10');//2020-10-18 RJS 2028
                    $("#L11F27").val('30');
                    $("#systemNotificationFileDownloaded").prop('checked', true);
                    $("#systemNotificationFileViewed").prop('checked', true);
                    CKEDITOR.instances.L11F29.setData(fnDefaultDownloadNotice());
                }
                else {
                    $("#largefileupload").hide();
                }
            }
            else {
                $("#largefileupload").hide();
            }
        } catch (e) {
            //Do nothing
        }
    }

    function fnDefaultDownloadNotice() {
        var $strMessage = "";
        $strMessage += "<table width=\"100%\" cellpadding=0 cellspacing=0 style=\"-moz-box-shadow: 5px 5px 5px #888;-webkit-box-shadow: 5px 5px 5px #888;box-shadow: 5px 5px 5px #888;\">";
        $strMessage += "	<tr>";
        $strMessage += "		<td style=\"background-color:#4980bd;border:1px solid #4980bd\" width=\"20px\">&nbsp;</td>";
        $strMessage += "		<td style=\"padding:20px;border:1px solid #eee; font-family:Helvetica Neue,Helvetica,Arial,sans-serif\">";
        //2020-10-18 RJS 2028
        $strMessage += "			<p style=\"font-size:16px;font-weight:bold\">The attachments with this email have been shared securely via Galaxkey Workspace.</p>";
        $strMessage += "			<p style=\"font-size:12px;\">Login to the following link to download the files.</p>";
        //2020-10-18 RJS 2028
        $strMessage += "			<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">";
        $strMessage += "			  <tr>";
        $strMessage += "			    <td>";
        $strMessage += "			      <div>";
        $strMessage += "			        <!--[if mso]>";
        $strMessage += "			          <v:roundrect xmlns_v=\"urn:schemas-microsoft-com:vml\" xmlns_w=\"urn:schemas-microsoft-com:office:word\" href=\"$WORKSPACE_URL$\" style=\"height:36px;v-text-anchor:middle;width:200px;\" arcsize=\"5%\" strokecolor=\"#4980bd\" fillcolor=\"#4980bd\">";
        $strMessage += "			            <w:anchorlock/>";
        $strMessage += "			            <center style=\"color:#ffffff;font-family:Helvetica, Arial,sans-serif;font-size:16px;\">Login to download</center>";
        $strMessage += "			          </v:roundrect>";
        $strMessage += "			        <![endif]-->";
        $strMessage += "			        <a href=\"$WORKSPACE_URL$\" style=\"background-color:#4980bd;border:1px solid #4980bd;border-radius:3px;color:#ffffff;display:inline-block;font-family:sans-serif;font-size:16px;line-height:44px;text-align:center;text-decoration:none;width:200px;-webkit-text-size-adjust:none;mso-hide:all;\">Login to download</a>";
        $strMessage += "			      </div>";
        $strMessage += "			    </td>";
        $strMessage += "			  </tr>";
        $strMessage += "			</table>";
        $strMessage += "			<p style=\"font-size:12px;\">The following files will be available to download until $EXPIRYDATE$.</p>";
        $strMessage += "			<p style=\"font-size:12px;\">$FILELIST$</p>";
        $strMessage += "		</td>";
        $strMessage += "	</tr>";
        $strMessage += "</table>";



        return $strMessage;
    }
    //2020-09-04 RJS 1883


    //2020-09-24 RJS 2056
    $(document).on('click', '#GF7', function (e) {
        fnProcessGF7();
    });

    function fnProcessGF7() {
        try {
            if ($("#GF7") != undefined && $("#GF7").prop('checked') != undefined) {
                var $bChecked = $("#GF7").prop('checked');
                if ($bChecked == true) {
                    $("#disclaimerMessage").show();
                    $("#GF8").val('');
                }
                else {
                    $("#disclaimerMessage").hide();
                }
            }
            else {
                $("#disclaimerMessage").hide();
            }
        } catch (e) {
            //Do nothing
        }
    }
    //2020-09-24 RJS 2056

});

