﻿
var iconDrag = "<span class='webix_icon fa-bars'></span>";
var iconEdit = "<span class='webix_icon fa-pencil'></span>";
var iconDelete = "<span class='webix_icon fa-trash'></span>";
var iconCopy = "<span class='webix_icon fa-copy'></span>";
var iconInfo = "<span class='webix_icon fa-info-circle'></span>";
var iconUp = "<span class='webix_icon fa-caret-up'></span>";
var iconDown = "<span class='webix_icon fa-caret-down'></span>";

var strWebixError = "";

var classificationcopy = [];
var classificationJSON = Array();


var Base64 = { _keyStr: "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=", encode: function (n) { var f = "", e, t, i, s, h, o, r, u = 0; for (n = Base64._utf8_encode(n) ; u < n.length;) e = n.charCodeAt(u++), t = n.charCodeAt(u++), i = n.charCodeAt(u++), s = e >> 2, h = (e & 3) << 4 | t >> 4, o = (t & 15) << 2 | i >> 6, r = i & 63, isNaN(t) ? o = r = 64 : isNaN(i) && (r = 64), f = f + this._keyStr.charAt(s) + this._keyStr.charAt(h) + this._keyStr.charAt(o) + this._keyStr.charAt(r); return f }, decode: function (n) { var t = "", e, o, s, h, u, r, f, i = 0; for (n = n.replace(/[^A-Za-z0-9\+\/\=]/g, "") ; i < n.length;) h = this._keyStr.indexOf(n.charAt(i++)), u = this._keyStr.indexOf(n.charAt(i++)), r = this._keyStr.indexOf(n.charAt(i++)), f = this._keyStr.indexOf(n.charAt(i++)), e = h << 2 | u >> 4, o = (u & 15) << 4 | r >> 2, s = (r & 3) << 6 | f, t = t + String.fromCharCode(e), r != 64 && (t = t + String.fromCharCode(o)), f != 64 && (t = t + String.fromCharCode(s)); return Base64._utf8_decode(t) }, _utf8_encode: function (n) { var i, r, t; for (n = n.replace(/\r\n/g, "\n"), i = "", r = 0; r < n.length; r++) t = n.charCodeAt(r), t < 128 ? i += String.fromCharCode(t) : t > 127 && t < 2048 ? (i += String.fromCharCode(t >> 6 | 192), i += String.fromCharCode(t & 63 | 128)) : (i += String.fromCharCode(t >> 12 | 224), i += String.fromCharCode(t >> 6 & 63 | 128), i += String.fromCharCode(t & 63 | 128)); return i }, _utf8_decode: function (n) { for (var r = "", t = 0, i = c1 = c2 = 0; t < n.length;) i = n.charCodeAt(t), i < 128 ? (r += String.fromCharCode(i), t++) : i > 191 && i < 224 ? (c2 = n.charCodeAt(t + 1), r += String.fromCharCode((i & 31) << 6 | c2 & 63), t += 2) : (c2 = n.charCodeAt(t + 1), c3 = n.charCodeAt(t + 2), r += String.fromCharCode((i & 15) << 12 | (c2 & 63) << 6 | c3 & 63), t += 3); return r } };
function showForm(n, t, i) {
    $$(n).getBody().focus();
    $$(n).show();
    if (i != -1) {
        var r = t[i];
       
        r.description = r.description.replace("&amp;", "&");
        r.description = r.description.replace("&lt;", "<");
        r.description = r.description.replace("&gt;", ">");


        $$("classifyForm").setValues({
            "name": r.name,
            "description": r.description,
            "default": r.default,
            "internal": r.internal,
            "fe": r.fe,
            "allow_down": r.allow_down,
            "index": r.index
        });
        nCurrentIndex = i
    }
    else {
        $$("classifyForm").setValues({
            "name": "New Classification",
            "description": "",
            "default": 0,
            "internal": 0,
            "fe": 0,
            "allow_down": 1,
            "index": -1
        });
    }


}

function copyClassifications() {
    classificationcopy = [];
    for (i = 0; i < classificationJSON.length; i++) {
        classificationcopy.push({
            "name": classificationJSON[i].name,
            "description": classificationJSON[i].description,
            "default": classificationJSON[i].default,
            "internal": classificationJSON[i].internal,
            "fe": classificationJSON[i].fe,
            "allow_down": classificationJSON[i].allow_down,
            "index": i
        });
    }
    if (classificationcopy.length > 0) {
        $$("pastebuttonForClassification").enable();
        webix.message({ type: "error", text: classificationcopy.length.toString() + " classification/s copied" })
    }
    else {
        $$("pastebuttonForClassification").disable();
    }
}

function fnGetUniqueName(name) {
    var bPresent = false;
    for (i = 0; i < classificationJSON.length; i++) {
        if (classificationJSON[i].name == name) {
            bPresent = true;
        }
    }
    if (bPresent == true) {
        var nSuf = 1;
        try {
            // Get the last part of the name, if the part is a number, we will increment it
            var pos = name.lastIndexOf(' ');
            if (pos != -1) {
                var strSuffix = name.substring(pos + 1);
                if (strSuffix != undefined && isNaN(strSuffix) == false) {
                    var nV = parseInt(strSuffix);
                    nSuf = nV + 1;
                    name = name.substring(0, pos);
                }
            }
        }
        catch (e) {
            // Do nothing
        }

        // Limit the length of name to 28 characters
        if (name.length > 28) {
            name = name.substring(0, 28);
        }
        name = name + " " + nSuf.toString();
        return fnGetUniqueName(name);
    }
    return name;
}

function pasteClassification() {
    var len = classificationcopy.length;
    if (len > 0) {
        webix.confirm({
            title: "Confirm", text: "Do you want to paste " + len.toString() + " classification/s in this list?", width: 400, callback: function (result) {
                
                if (result == true) {
                    for (var i = 0; i < classificationcopy.length; i++) {
                        var rname = classificationcopy[i].description;
                        // Check if the classification name is already present
                        rname = fnGetUniqueName(rname);
                        classificationJSON.push({
                            "name": classificationcopy[i].name,
                            "description": classificationcopy[i].description,
                            "default": classificationcopy[i].default,
                            "internal": classificationcopy[i].internal,
                            "fe": classificationcopy[i].fe,
                            "allow_down": classificationcopy[i].allow_down,
                            "index": classificationJSON.length
                        });
                    }
                    bDirtyFlag = true;
                    $$("classficationListing").clearAll();
                    $$("classficationListing").parse(classificationJSON);
                }
            }
        });
    }
    else {
        $$("pastebuttonForClassification").disable();
    }
}

var nCurrentIndex = -1;
var nTableId = -1;
var nRowID = -1;



webix.ready(function () {

   var form = {
        id: "classifyForm", view: "form", borderless: !0,
        elements: [
         { view: "text", label: "Name", name: "name", attributes: { maxlength: 30 } },
         { view: "text", label: "Description", name: "description", attributes: { maxlength: 256 } },
        {
            cols: [
                    { view: "checkbox", label: "Default", name: "default", value: 0},
                    { view: "checkbox", label: "Internal", name: "internal", value: 0}
            ]
        },
        {
            cols: [
                    { view: "checkbox", label: "Force Encryption", name: "fe", value: 0},
                    { view: "checkbox", label: "Allow Change Down", name: "allow_down", value: 1}
            ]
        },
        {
            cols: [{
                view: "button", value: "Save", click: function () {
                    if (this.getParentView().getParentView().validate()) {
                        
                        var n = this.getParentView().getParentView().getValues();
                        n.description = $.trim(n.description);
                        n.description = n.description.replace("&", "&amp;");
                        n.description = n.description.replace("<", "&lt;");
                        n.description = n.description.replace(">", "&gt;");
                        n.name = $.trim(n.name);
                        n.name = n.name.replace("&", "&amp;");
                        n.name = n.name.replace("<", "&lt;");
                        n.name = n.name.replace(">", "&gt;");
                        
                        // If the default is set, we will remove default from other entries
                        if (n.default == true)
                        {
                            for(i=0;i<classificationJSON.length;i++)
                            {
                                classificationJSON[i].default = false;
                            }
                        }
                        if (nCurrentIndex != -1) {
                            n.index = nCurrentIndex;
                            classificationJSON[nCurrentIndex] = n;
                        }
                        else {
                            n.index = classificationJSON.length;
                            classificationJSON.push(n);
                        }
                        bDirtyFlag = true;
                        $$("classficationListing").clearAll();
                        $$("classficationListing").parse(classificationJSON);
                        this.getTopParentView().hide()
                        
                    }
                    else {
                        webix.message({ type: "error", text: strWebixError });
                        strWebixError = "";
                    }
                }
            },
            {
                view: "button", value: "Cancel", click: function () { this.getParentView().getTopParentView().hide() }
            }]
        }], rules: {
            name: function (n) {
                var bReturn = true;
                n = $.trim(n);
                n = encodeURIComponent(n);
                if (n != undefined && n != "") {
                    for (i = 0; i < classificationJSON.length; i++) if (nCurrentIndex != i) {
                        var t = classificationJSON[i]; if (encodeURIComponent(t.name) == n) 
                        {
                            strWebixError = "The classification name is already defined!";
                            bReturn = false;
                            break;
                        }
                    }
                }
                return bReturn;
            },
            description: function (n) {
                var bReturn = true;
                n = $.trim(n);
                if (n == undefined || n == "") {
                    strWebixError = "Please enter a valid description!";
                    bReturn = false;
                }
                return bReturn;
            }
            
        },
        elementsConfig: { labelPosition: "left", labelWidth: 140 }
    };


    webix.ui({ view: "window", id: "ClassificationDefinitionWin", width: 600, position: "center", modal: !0, head: "Policy Classification Definition", body: webix.copy(form) });



    var classificationGrid = webix.ui({
        container: "classificationmanager",
        rows: [
            {
                view: "toolbar",
                id: "classificationToolbar", height: 42,
                cols: [
                    { view: "label", type: "icon", label: "Classifications", width: 250, align: "left" },
                    { gravity: 3 },
     //               { id: "pastebuttonForClassification", view: "button", type: "icon", icon: "paste", label: "Paste", click: "pasteClassification();", disabled: true },
					//{ id: "copybuttonForClassification", view: "button", type: "icon", icon: "copy", label: "Copy all", click: "copyClassifications();" },
                    { view: "button", type: "icon", icon: "plus", label: "Add new", click: "nCurrentIndex=-1;showForm('ClassificationDefinitionWin', classificationJSON, -1)" }
                ]
            },
            {
                id: 'classficationListing',
                autoheight: true,
                autowidth: true,
                view: "datatable",
                columns: [
                    { id: "name", header: "Classification Name", width: 150 },
                    { id: "description", header: "Description", width: 175 },
                    { id: "default", header: "Default", width: 65, template: function (obj) { return (obj.default == 1) ? "&#10003;" : ""; }, css: { "text-align": "center" } },
                    { id: "internal", header: "Internal", width: 65, template: function (obj) { return (obj.internal == 1) ? "&#10003;" : ""; }, css: { "text-align": "center" } },
                    { id: "fe", header: "Encrypt", width: 65, template: function (obj) { return (obj.fe == 1) ? "&#10003;" : ""; }, css: { "text-align": "center" } },
                    { id: "allow_down", header: "Allow Down", width: 65, template: function (obj) { return (obj.allow_down == 1) ? "&#10003;" : ""; }, css: { "text-align": "center" } },
                    { id: "action", header: "", width: 120, template: iconUp + iconDown + iconCopy + iconDelete + iconEdit, css: { "text-align": "center" } }
                ],
                onClick: {
                    "fa-caret-up": function (e, id) {
                        var nCurrentIndex = this.getItem(id).index;
                        if (nCurrentIndex > 0) {
                            var temp = classificationJSON[nCurrentIndex];
                            classificationJSON[nCurrentIndex] = classificationJSON[nCurrentIndex - 1];
                            classificationJSON[nCurrentIndex - 1] = temp;
                            classificationJSON[nCurrentIndex].index += 1;
                            classificationJSON[nCurrentIndex - 1].index -= 1;
                            $$("classficationListing").clearAll();
                            $$("classficationListing").parse(classificationJSON);
                        }
                    },
                    "fa-caret-down": function (e, id) {
                        var nCurrentIndex = this.getItem(id).index;
                        if (nCurrentIndex < classificationJSON.length-1) {
                            var temp = classificationJSON[nCurrentIndex];
                            classificationJSON[nCurrentIndex] = classificationJSON[nCurrentIndex + 1];
                            classificationJSON[nCurrentIndex + 1] = temp;
                            classificationJSON[nCurrentIndex].index -= 1;
                            classificationJSON[nCurrentIndex + 1].index += 1;
                            $$("classficationListing").clearAll();
                            $$("classficationListing").parse(classificationJSON);
                        }
                    },
                    "fa-pencil": function (e, id) {
                        nCurrentIndex = this.getItem(id).index;
                        showForm("ClassificationDefinitionWin", classificationJSON, this.getItem(id).index);
                    },
                    "fa-copy": function (e, id) {
                        nCurrentIndex = this.getItem(id).index;
                        classificationcopy = [];
                        classificationcopy.push({
                            "name": classificationJSON[nCurrentIndex].name,
                            "description": classificationJSON[nCurrentIndex].description,
                            "default": classificationJSON[nCurrentIndex].default,
                            "internal": classificationJSON[nCurrentIndex].internal,
                            "fe": classificationJSON[nCurrentIndex].fe,
                            "allow_down": classificationJSON[nCurrentIndex].allow_down,
                            "index": 0
                        });
                        if (classificationcopy.length > 0) {
                            $$("pastebuttonForClassification").enable();
                            webix.message({ type: "error", text: "One classification copied" })
                        }
                        else {
                            $$("pastebuttonForClassification").disable();
                        }
                    },
                    "fa-trash": function (e, id) {
                        nTableId = this.getItem(id).index;
                        nRowID = id;
                        webix.confirm({
                            title: "Confirm", text: "Do you want to delete the classification: " + this.getItem(id).name, callback: function (result) {
                                if (result == true) {
                                    for (var i = classificationJSON.length - 1; i >= 0; i--) {
                                        if (classificationJSON[i].index == nTableId) {
                                            classificationJSON.splice(i, 1);
                                            $$("classficationListing").remove(nRowID);
                                            break;
                                        }
                                    }
                                    // Update the index
                                    for (var i = classificationJSON.length - 1; i >= 0; i--) {
                                        classificationJSON[i].index = i;
                                    }
                                    bDirtyFlag = true;
                                }
                            }
                        });
                    }

                }
            }
        ]
    });


    $$("classficationListing").parse(classificationJSON);

});